
#pragma once

#ifndef _LAGARITH_COMPRESSION 
#define _LAGARITH_COMPRESSION 

class CompressClass {

public:
	unsigned int * prob_ranges;		// Byte probablity range table
	unsigned int scale;				// Used to replace some multiply/divides with binary shifts,
									// (1<<scale) is equal to the cumulative probabilty of all bytes
	unsigned int * bytecounts;		// Byte frequency table
	unsigned char * buffer;			// buffer to perform RLE
	//unsigned char * header;			// used by old_uncompact


	CompressClass();
	~CompressClass();

	bool InitCompressBuffers(const unsigned int length);
	void FreeCompressBuffers();

	unsigned int compact( const unsigned char * in, unsigned char * out, const unsigned int length, const bool yuy2_lum=false);
	void uncompact( const unsigned char * in, unsigned char * out, const unsigned int length);
	void calcprob(const unsigned char * in, const unsigned int length);
	void calcprob2(const unsigned char * in, const unsigned int length);
	void scaleprob(const unsigned int length);
	unsigned int readprob(const unsigned char * in);
	void readprob2(const unsigned char * in, const unsigned int length);
	unsigned int encode( const unsigned char * in, unsigned char * out, const unsigned int length);
	void decode(const unsigned char *in, unsigned char *out, const unsigned int length);

	void old_uncompact( const unsigned char * in, unsigned char * out, const unsigned int length);
	unsigned int old_readprob(const unsigned char * in);
};

#endif